<!-- 
This README describes the package. If you publish this package to pub.dev,
this README's contents appear on the landing page for your package.

For information about how to write a good package README, see the guide for
[writing package pages](https://dart.dev/guides/libraries/writing-package-pages). 

For general information about developing packages, see the Dart guide for
[creating packages](https://dart.dev/guides/libraries/create-library-packages)
and the Flutter guide for
[developing packages and plugins](https://flutter.dev/developing-packages). 
-->

Using this package to sign in all social platform like Google login, Apple login, Facebook, LinkedIn

## Features
- All Social Sign In implementations in a single package.
- Login on iOS and Android.
- Reduce line of code and package installation
 

## Getting started

before write a code :
- <b>It is necessary to create firebase project and insert google json file in your project and enable Authentication</b>
- <b>It is necessary to configure the platform which you are using</b>
- <b>Import [firebase_auth](https://pub.dev/packages/firebase_auth "firebase_auth") package for accessing User class</b>

### Google login
[Google login](https://pub.dev/packages/google_sign_in "Google login")

### Apple login
[Apple login](https://pub.dev/packages/sign_in_with_apple "Apple login")

### Facebook login
[Facebook login](https://pub.dev/packages/flutter_facebook_auth "Facebook login")

### LinkedIn login
[LinkedIn login](https://pub.dev/packages/linkedin_login "LinkedIn login")

## Usage

just call this methods 

### Google login

```dart
    void googleLogin() {
      SocialLoginUtils().signInWithGoogle(context,isDisplayProgressBar: true,).then((userData) {
        //return type is User ('package:firebase_auth/firebase_auth.dart')
        if(userData!=null){
          Navigator.of(context)
              .push(PageRouteBuilder(
            pageBuilder: (BuildContext context, Animation<double> animation,
                Animation<double> secondaryAnimation) =>
                DashboardPage(userData:userData),
            transitionDuration: Duration(seconds: 0),
          ));
        }
      });
    }
```

### Apple login
if platform is android, pass clientID is mandatory
```dart
    void appleLogin() {
      SocialLoginUtils().appleLogin(context,Platform.isAndroid,isDisplayProgressBar: true,
          clientID: "as_given_doc"
      ).then((userData) {
        //return type is User ('package:firebase_auth/firebase_auth.dart')
        if(userData!=null){
          Navigator.of(context)
              .push(PageRouteBuilder(
            pageBuilder: (BuildContext context, Animation<double> animation,
                Animation<double> secondaryAnimation) =>
                DashboardPage(userData:userData),
            transitionDuration: Duration(seconds: 0),
          ));
        }
      });
    }
```

### Facebook login

```dart
    void facebookLogin() {
      SocialLoginUtils().signInWithFacebook(context,isDisplayProgressBar: true,).then((userData) {
        //return type is User ('package:firebase_auth/firebase_auth.dart')
        if(userData!=null){
          Navigator.of(context)
              .push(PageRouteBuilder(
            pageBuilder: (BuildContext context, Animation<double> animation,
                Animation<double> secondaryAnimation) =>
                DashboardPage(userData:userData),
            transitionDuration: Duration(seconds: 0),
          ));
        }
      });
    }
```

### LinkedIn login
for logout set destroySession=false;
```dart
    void linkedInLogin() {
      SocialLoginUtils().signInWithLinkedIn(context,isDisplayProgressBar: true,
          clientId:'CLIENT_ID' ,clientSecret:'CLIENT_SECRET' ,redirectUrl: 'REDIRECT_URL',
          appBar:AppBar(title: Text("All Social login"),),
          destroySession: false
      ).then((userData) {
        //return type is MAP<String, dynamic> 
        if(userData!=null){
          Navigator.of(context)
              .push(PageRouteBuilder(
            pageBuilder: (BuildContext context, Animation<double> animation,
                Animation<double> secondaryAnimation) =>
                DashboardPage(mapUserData:userData),
            transitionDuration: Duration(seconds: 0),
          ));
        }
      });
    }
```

## Additional information
 The main goal of writing this package to reduce line of code. Once sign in you need to Logout.
