import 'package:flutter/material.dart';
import 'package:firebase_auth/firebase_auth.dart';
import 'package:flutter_all_social_login/flutter_all_social_login.dart';
class DashboardPage extends StatefulWidget {
  User? userData;
  Map<String,dynamic>? mapUserData;
  DashboardPage({Key? key,this.userData,this.mapUserData}) : super(key: key);

  @override
  State<DashboardPage> createState() => _DashboardPageState();
}

class _DashboardPageState extends State<DashboardPage> {


  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text("Dashboard"),
      ),
      body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Text("Name: ${_getName()}"),
            GestureDetector(
                onTap: () {
                  SocialLoginUtils().signOut().then((value) {
                    print("value=="+value.toString());
                    if(value!=null && value){
                      SocialLoginUtils().showToastMessage("Logout Successfull");
                      Navigator.pop(context);
                    }
                  });
                },
                child:Container(
                  height: 40,
                  decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(20),
                      color: Colors.white),
                  alignment: Alignment.center,
                  padding: const EdgeInsets.all(10),
                  margin: const EdgeInsets.all(10),
                  child:const Text("Google Login out"),
                )),
          ],
        ),
      ),
      // This trailing comma makes auto-formatting nicer for build methods.
    );
  }

  _getName(){
    if(widget.mapUserData!=null && widget.mapUserData!["firstName"]!=null){
      return widget.mapUserData!["firstName"];
    }else if(widget.userData!=null){
      return widget.userData!.displayName.toString();
    }else{
      return "";
    }

  }
}
