import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

class ProgressDialog {
  static OverlayEntry? currentLoader;
  static  bool isShowing = false;
  static  bool isDisplay = false;
  static late Color progressBarColor;
  static void show(BuildContext context,Color progressBarColors,bool isDisplays) {
    isDisplay=isDisplays;

    progressBarColor=progressBarColors;
    if (isDisplay && !isShowing) {
      currentLoader = OverlayEntry(
        builder: (context) => GestureDetector(
          child: Container(
            color: Colors.transparent,
            width: MediaQuery.of(context).size.width,
            height: MediaQuery.of(context).size.height,
            child: Center(
              child: Column(
                mainAxisAlignment: MainAxisAlignment.center,
                children: <Widget>[
                  Container(
                    child: getCircularProgressIndicator(),
                    width: 50,
                    height: 50,
                    padding: EdgeInsets.all(8.0),
                    decoration: BoxDecoration(
                        borderRadius: BorderRadius.circular(100),
                        color: Colors.white,
                        border: Border.all(
                            width: 1, color: progressBarColor)),
                  )
                ],
              ),
            ),
          ),
          onTap: () {
            // do nothing
          },
          onDoubleTap: () {
            ProgressDialog.hide();
          },
        ),
      );
      Overlay.of(context)?.insert(currentLoader!);
      isShowing = true;
    }
  }

  static void hide() {
    if (currentLoader != null) {
      currentLoader?.remove();
      isShowing = false;
      currentLoader = null;
    }
  }

  static getCircularProgressIndicator({double? height, double? width}) {
    height ??= 40.0;
    width ??= 40.0;
    return Container(
      alignment: Alignment.center,
      child: SizedBox(
        height: height,
        width: width,
        child: CircularProgressIndicator(
          valueColor:  AlwaysStoppedAnimation<Color>(progressBarColor),
        ),
      ),
    );
  }

  static getErrorWidget() {
    return Container(
      alignment: Alignment.center,
      child: const SizedBox(
        child: Text("Oops! Something went wrong."),
      ),
    );
  }
}
